What is ASTK?
===============

**ASTK** is a command-line software for comprehensive alternative splicing analysis including:
- characterizing distribution and expression patterns of alternative splicing events
- systematically analyzing functional effects of AS events at the gene- and exon-level respectively
- dissecting out splicing-associated sequence features and epigenetic marks
- inferring the splicing regulatory code for each type of AS. 

<img src='https://huang-sh.github.io/astk-doc/static/img/workflow.png' alt="workflow.png"></img>

Documentation
===============
The documentation for ***ASTK*** is available on [astk-doc](https://huang-sh.github.io/astk-doc/).

How to cite
===============
Huang, S., He, J., Yu, L., Guo, J., Jiang, S., Sun, Z., Cheng, L., Chen, X., Ji, X. and Zhang, Y. (2024), ASTK: A Machine Learning-Based Integrative Software for Alternative Splicing Analysis. Adv. Intell. Syst. 2300594. https://doi.org/10.1002/aisy.202300594


How to contact
===============

- Shenghui Huang (hsh-me@outlook.com)

suppressMessages(library(tidyverse))
suppressMessages(library(clusterProfiler))


args <- commandArgs()

out.dir <- args[6]
pval  <- as.numeric(args[7])
org_db <- args[8]
ont <- args[9]
gene_type <- args[10]
name <- args[11]
database <- args[12]
organism <- args[13]
dpsi_file <- args[14]

script_path  <- str_split(args[4], "=")[[1]][2]
source(file.path(dirname(script_path), "utils.R"))

OrgDb <- load_OrgDb(org_db)

dpsi_df <- read_tsv(dpsi_file, 
                    skip      = 1, 
                    col_names = F,
                    col_types = cols("c", "d", "d")) %>% 
                    drop_na()

colnames(dpsi_df) = c("event_id", "dpsi", "pval")

if (gene_type == "ENSEMBL"){
    dpsi_df$gene <- gsub("\\..*", "",  dpsi_df$event_id) 
} else {
    dpsi_df$gene <- gsub(";.*", "",  dpsi_df$event_id)
}


dpis_gene <- sapply(unique(dpsi_df$gene), function(x){
    scores <- dpsi_df[dpsi_df$gene == x, ]$dpsi
    pos_score <- sum(scores[scores > 0])
    neg_score <- sum(scores[scores < 0])
    if (pos_score > abs(neg_score)){
        return(pos_score)
    } else{
        return(neg_score)
    }
    
})


dpis_gene.sort <- sort(dpis_gene, decreasing=TRUE)

if (database == "GO"){
    gse <- gseGO(geneList    = dpis_gene.sort,
                OrgDb        = OrgDb,
                ont          = ont,
                pvalueCutoff = pval,
                verbose      = FALSE,
                keyType      = gene_type)

} else if (database == "KEGG") {
    if (gene_type == 'ENTREZID'){
        dpis_gene.sort <- dpis_gene.sort
    } else {
        genes <- names(dpis_gene.sort)
        gene_df <- bitr(genes, fromType = gene_type, toType = "ENTREZID", OrgDb = OrgDb)
        new.gene.sort <- dpis_gene.sort[gene_df[, gene_type]]
        names(new.gene.sort) <- gene_df$ENTREZID
    }    
    gse <- gseKEGG(geneList    = new.gene.sort,
                  organism     = organism,
                  pvalueCutoff = pval,
                  verbose      = FALSE)
}


RData.out <- file.path(out.dir, sprintf("%s.%s", name, "RData"))
csv.out <- file.path(out.dir, sprintf("%s.%s", name, "csv"))

if (dim(gse)[1] == 0){
    stop("No enrichment found in input...")
} else {
    keyType <- ifelse(database == "KEGG", "ENTREZID", gene_type)
    ego <- setReadable(gse, OrgDb = OrgDb, keyType = keyType)
    save(gse, file = RData.out)
    write_csv(as.data.frame(gse), file = csv.out)        
}

library(stringr)
library(ggplot2)
suppressMessages(library(dplyr))
suppressMessages(library(readr))


args <- commandArgs()

out <- args[6]
psi_files <- args[7:length(args)]


psi_df_ls <- lapply(psi_files, function(file){
    psi_df <- read_tsv(file, col_types = cols("c", "d", "d"))
    return(psi_df)
})

names <- lapply(psi_files, function(file){
    name <- tools::file_path_sans_ext(basename(file))
    psi_df <- read_tsv(file, col_types = cols("c", "d", "d"))
    rep(name, dim(psi_df)[2]-1)
})

my_inner_join <- function(x, y){
    inner_join(x, y, by = "event_id")
}

dat <- Reduce(my_inner_join, psi_df_ls)


dat <- na.omit(dat)
df_pca <- prcomp(t(dat[, -1]))

df <- as.data.frame(df_pca$x)

df$group <- unlist(names)



percentage <- round(df_pca$sdev / sum(df_pca$sdev) * 100, 2)

percentage <- paste(colnames(df), "(", paste( as.character(percentage), "%", ")", sep="") )

p <- ggplot(df, aes(x=PC1,y=PC2, color=group)) +
    geom_point()+xlab(percentage[1]) + 
    ylab(percentage[2])


ggsave(out, plot = p)

suppressMessages(library(tidyverse))
suppressMessages(library(clusterProfiler))


args <- commandArgs()

out.dir <- args[6]
pval  <- as.numeric(args[7])
qval  <- as.numeric(args[8])
db <- args[9]
cluster <- args[10] 
org_db <- args[11]
gene_id <- args[12]
kegg_organism <- args[13]
dpsi_files <- args[14:length(args)]

suppressMessages(library(org_db, character.only = T))

script_path  <- str_split(args[4], "=")[[1]][2]
source(file.path(dirname(script_path), "utils.R"))


cls_ext <- tools::file_ext(cluster)

if (cls_ext == "tsv"){
    exon_cluster <- read_tsv(cluster)
}else if (cls_ext == "csv") {
    exon_cluster <- read_csv(cluster)
}

exon_cluster$geneId <- gsub("\\..*", "",  exon_cluster$geneId) 

unique_exon_cls <- exon_cluster %>% 
    distinct(cluster, geneId) 

if (length(dpsi_files) == 1){
    file  <-  dpsi_files[1]

    dpsi <- read_tsv(file, 
                     skip =1, 
                     col_names = F,
                     col_types = cols("c", "d", "d"))
    fn  <-  tools::file_path_sans_ext(basename(file))

    genes <- gsub("\\..*", "",  dpsi$X1)                             
    
    sig_genes <- unique_exon_cls %>% 
        filter(geneId %in% genes)

    clusters <- sort(unique(sig_genes$cluster))
    gene_ls <- lapply(clusters, function(x){
        cg <- sig_genes %>% 
            filter(cluster == x)
        cg$geneId
    })
    names(gene_ls) <- paste("cluster", clusters, sep = "")
    if (db == "GO"){
        compareClusterSep(gene_ls, 
                          out.dir, 
                          org_db, 
                          name    = fn,
                          keyType = gene_id,
                          pval    = pval, 
                          qval    = qval)
    }else if (db == "KEGG") {
        compareKEGGCluster(gene_ls, 
                          out.dir, 
                          org_db, 
                          kegg_organism, 
                          name    = paste("KEGG", fn, sep="_"), 
                          keyType = gene_id, 
                          pval    = pval, 
                          qval    = qval)
    }


} else if (length(dpsi_files) > 1){
    dpsi_ls <- lapply(dpsi_files, function(file){
        dpsi <- read_tsv(file, 
                         skip      = 1, 
                         col_names = F,
                         col_types = cols("c", "d", "d"))
        colnames(dpsi) = c("event_id", "dpsi", "pval")
        return(dpsi)
    })
    dpsi_merge <- Reduce(rbind, dpsi_ls)
    genes <-gsub("\\..*", "",  dpsi_merge$event_id) 

    sig_genes <- unique_exon_cls %>% 
        filter(geneId %in% genes)

    clusters <- sort(unique(sig_genes$cluster))
    gene_ls <- lapply(clusters, function(x){
        cg <- sig_genes %>% 
            filter(cluster == x)
        cg$geneId
    })

    names(gene_ls) <- paste("cluster", clusters, sep = "")

    if (db == "GO"){
        compareClusterSep(gene_ls, 
                          out.dir, org_db, 
                          name    = "merge",
                          keyType = gene_id,
                          pval    = pval, 
                          qval    = qval)
    }else if (db == "KEGG") {
        compareKEGGCluster(gene_ls, 
                           out.dir, 
                           org_db, 
                           kegg_organism, 
                           name    = "KEGG_merge", 
                           keyType = gene_id, 
                           pval    = pval, 
                           qval    = qval)
    }
}

print("Done")

CRAN_url <- c("https://cloud.r-project.org/", 
        "https://mirrors.tuna.tsinghua.edu.cn/CRAN/")

if (!("argparse" %in% rownames(installed.packages()))){
    options("repos" = CRAN_url)
    install.packages("argparse")
} 

parser <- argparse::ArgumentParser()
parser$add_argument("--requirement", action='store_true')
parser$add_argument("--OrgDb", nargs='+')
parser$add_argument("--CRAN", nargs='+')
parser$add_argument("--bioconductor", nargs='+')
parser$add_argument("--mirror", action='store_true')

args <- parser$parse_args()

if (args$mirror){
    options(BioC_mirror="https://mirrors.tuna.tsinghua.edu.cn/bioconductor")
    options("repos" = c(CRAN="https://mirrors.tuna.tsinghua.edu.cn/CRAN/"))
} else {
   options("repos" = CRAN_url)
}

if (args$requirement){
    ## Install packages from Cran

    cran.packages <- c("tidyverse", "ggplot2", "argparse", 
                       "UpSetR", "eoffice", "ggnewscale")

    for(i in cran.packages){
    if(!(i %in% rownames(installed.packages()))){
        message('Installing package: ', i)
        install.packages(i, dependencies = T)
    } else 
        next
    }
    ## Install packages from Bioconductor

    bioconductor.packages <- c('clusterProfiler', 'org.Mm.eg.db', 'org.Hs.eg.db',
             'simplifyEnrichment', 'universalmotif', 'memes')

    if (!requireNamespace("BiocManager", quietly = TRUE))
        install.packages("BiocManager")
    for(i in bioconductor.packages){
        if(!(i %in% rownames(installed.packages()))){
            message('Installing package: ', i)
            BiocManager::install(i, dependencies = T)
    } else 
        next
    }    
}

if (! is.null(args$OrgDb)){

    if (!requireNamespace("BiocManager", quietly = TRUE)){
        install.packages("BiocManager")
    }else {
        for (i in args$OrgDb){
            if(!(i %in% rownames(installed.packages()))){
                message('Installing package: ', i)
                BiocManager::install(i)
            } else 
                next
        }
    }
}

if (! is.null(args$CRAN)){
    for (i in args$CRAN){
        if(!(i %in% rownames(installed.packages()))){
            message('Installing package: ', i)
            install.packages(i)
        } else 
            next
    }
    
}

if (! is.null(args$bioconductor)){
    if (!requireNamespace("BiocManager", quietly = TRUE)){
        install.packages("BiocManager")
    }
    for (i in args$bioconductor){
        if(!(i %in% rownames(installed.packages()))){
            message('Installing package: ', i)
            BiocManager::install(i)
        } else 
            next
    }    
}

suppressMessages(library(stringr))
suppressMessages(library(readr))
suppressMessages(library(ComplexHeatmap))

args <- commandArgs()

file <- args[6]


if (str_detect(file, "_overlap")){

    data <- read_tsv(file)
    mat <- data[-7, -1]
    colnames(mat) <- sapply(str_split(colnames(data)[-c(1)], "\\."), function(x)x[1])

    pmat <- scale(mat)
    name <- str_split(basename(file), "_overlap")[[1]][1]

    p <- Heatmap(pmat, name=name, cluster_columns = F, cluster_rows = F,
               column_title = "Category", column_title_side = "bottom",
               row_title = "State (Emission order)"
                )
    png(str_replace(file, ".txt", ".png"),
        width = dim(mat)[2] * 30, height = dim(mat)[1] * 50)
    print(p)
    dev.off()
}

script_path  <- stringr::str_split(commandArgs()[4], "=")[[1]][2]
source(file.path(dirname(script_path), "utils.R"))


parser <- fig_cmd_parser()

parser$add_argument("--RData", help="RData file path")
parser$add_argument("--termid", nargs='+', help="term id")


args <- parser$parse_args()


load(args$RData)

term_ID <- args$termid
if (is.null(term_ID)){
    if (dim(gse)[1] > 0){
        term_ID  <- gse$ID[1:min(c(5, dim(gse)))]
    }else {
        pdf(args$output)
        dev.off()
        invokeRestart("abort")
    }

}

if (length(term_ID) == 1){
    p <- enrichplot::gseaplot(gse, 
                  geneSetID = term_ID,
                  by        = "all", 
                  title     = gse[term_ID, "Description"])

}else {
    p <- enrichplot::gseaplot2(
                gse, 
                geneSetID = term_ID,
                title     = "GSEA")
}


save_fig(p, 
        args$output, 
        format = args$fmt,
        width  = args$width, 
        height = args$height, 
        units  = "in",
        res    = args$resolution)

library(stringr)
library(ggplot2)
suppressMessages(library(dplyr))
suppressMessages(library(readr))
suppressMessages(library(ComplexHeatmap))

args <- commandArgs()

out <- args[6]
cluster_file <- args[7]
psi_files <- args[8:length(args)]


psi_df_ls <- lapply(psi_files, function(file){
    psi_df <- read_tsv(file, col_types = cols("c", "d", "d"))
    return(psi_df)
})


my_inner_join <- function(x, y){
    inner_join(x, y, by = "event_id")
}

dat <- Reduce(my_inner_join, psi_df_ls)
dat <- na.omit(dat)


if (file.exists(cluster_file)){

    cls_ext <- tools::file_ext(cluster_file)

    if (cls_ext == "tsv"){
        exon_cluster <- read_tsv(cluster_file, show_col_types = FALSE)
    } else if (cls_ext == "csv") {
        exon_cluster <- read_csv(cluster_file, show_col_types = FALSE)
    }

    exon_cluster <- as.data.frame(exon_cluster)
    rownames(exon_cluster) <- exon_cluster$event_id

    exon_cluster[dat$event_id, ]$cluster
    split <- paste("Cluster", exon_cluster[dat$event_id, ]$cluster, sep = "")
} else {
   split <- NULL
}



col_fun <- circlize::colorRamp2(seq(0, 1, length.out = 9), 
            c('#0077B6', '#00B4D8', '#90E0EF', '#CAF0F8',
               '#FAE0E4', '#F9BEC7', '#FF99AC', '#FF7096', '#FF477E'))


p <- Heatmap(dat[, -1], 
             name = "Heatmap", 
             show_row_dend  = T, 
             border = TRUE, 
             col = col_fun,
             cluster_columns = F, 
             row_split  = split, 
             row_gap = unit(c(3), "mm"))


if (str_detect(out, "pdf")){
    pdf(out)
    print(p)
    dev.off()    
}else if (str_detect(out, "png")) {
    png(out)
    print(p)
    dev.off()   
}

library(memes)
library(tidyverse)



args <- commandArgs()

outdir <- args[6]
meme_db_path <- args[7]

files <- args[8:length(args)]



res_ls <- lapply(files, function(file){
    out.dir <- file.path(outdir, tools::file_path_sans_ext(basename(file)))
    runAme(file , database = meme_db_path, outdir=out.dir)    
})

file_names <- sapply(files, function(file)tools::file_path_sans_ext(basename(file)))
names(res_ls) <- file_names


data <- res_ls %>% 
    dplyr::bind_rows(.id = "condition") %>% 
    dplyr::group_by(condition) %>% 
    dplyr:: slice_head(n = 25) %>%   ## 选取了前25个motif
    ungroup()

plot <- plot_ame_heatmap(data, group = condition)

ggsave(file.path(outdir, "heatmap.pdf"), plot = plot)

parser <- argparse::ArgumentParser()

parser$add_argument("--gtf", help="gtf")
parser$add_argument("--organism", help="organism")
parser$add_argument("--output", help="output")

args <- parser$parse_args()


txdb <- GenomicFeatures::makeTxDbFromGFF(
                        args$gtf,
                        format="gtf",
                        organism=args$organism,
                        dbxrefTag = "gene_name")


AnnotationDbi::saveDb(txdb, args$output)

args <- commandArgs()

out.file <- args[6]
RData.file <- args[7]
term_ID <- args[8:length(args)]

load(RData.file)

if (length(term_ID) == 1){
    p <- enrichplot::gseaplot(gse, 
                  geneSetID = term_ID,
                  by        = "all", 
                  title     = gse[term_ID, "Description"])

}else {
    p <- enrichplot::gseaplot2(
                gse, 
                geneSetID = term_ID,
                title     = "GSEA")
}

ggplot2::ggsave(out.file, plot = p)

prepare_KEGG <- function(species, KEGG_Type = "KEGG", keyType = "kegg"){
    astk_dir <- file.path(path.expand('~'), ".astk", "kegg")  
    if (!dir.exists(astk_dir)){
      dir.create(astk_dir, recursive=T)
    }
    kegg_data_name <- paste(species, lubridate::today(),keyType,"RData", sep = ".")
    kegg_data_path <- file.path(astk_dir, kegg_data_name)

    if (file.exists(kegg_data_path)){
        print("load local catch")
        load(kegg_data_path)
    }else {
      print("online downloading... ")
      kegg <- clusterProfiler::download_KEGG(species, KEGG_Type, keyType)
      clusterProfiler:::build_Anno(kegg$KEGGPATHID2EXTID, kegg$KEGGPATHID2NAME)
      save(KEGG_DATA, file = kegg_data_path) 
    }
    return(KEGG_DATA)
}


enrichGOSep <- function(
                        gene, 
                        output, 
                        OrgDb, 
                        name    = "GO",
                        ont     = "BP",
                        keyType = 'ENTREZID',
                        pval    = 0.1, 
                        qval    = 0.1,
                        simple  = F,
                        width   = 12, 
                        height  = 10,
                        format  = "pdf") {
  
    ego <- enrichGO(
                    gene          = gene,
                    keyType       = keyType,
                    OrgDb         = OrgDb,
                    ont           = ont,
                    pAdjustMethod = "BH",
                    pvalueCutoff  = pval,
                    qvalueCutoff  = qval,
                    readable      = TRUE,
                    pool          = FALSE)

    outputf <- file.path(output, paste(name, ".%s.qval%s_pval%s.%s", sep = "")) 
    out.pdf <- sprintf(outputf, ont, qval, pval, format)

    if (dim(as.data.frame(ego))[1] == 0){
      print("NO enrichment")
      return()
    }
    print(ont)
    p_title <- ont
     
    out.csv <- file.path(output, paste(name, ".%s.qval%s_pval%s.csv", sep = ""))
    
    write.csv(as.data.frame(ego), file = sprintf(out.csv, ont, qval, pval))

    if (ont == "ALL"){
      p <- dotplot(ego, split="ONTOLOGY", showCategory = 15, title = p_title) + 
                facet_grid(ONTOLOGY~., scale="free") + 
                scale_color_gradientn(colours = c("#b3eebe", "#46bac2", "#371ea3"),
                                      guide   = guide_colorbar(reverse=TRUE, order=1)) +
                guides(size = guide_legend(override.aes=list(shape=1))) +
                theme(panel.grid.major.y = element_line(linetype='dotted', color='#808080'),
                      panel.grid.major.x = element_blank())                                      
    }else {
       p <- dotplot(ego, showCategory=30, title = p_title) + 
                scale_color_gradientn(colours = c("#b3eebe", "#46bac2", "#371ea3"),
                                      guide   = guide_colorbar(reverse=TRUE, order=1)) +
                guides(size = guide_legend(override.aes=list(shape=1))) +
                theme(panel.grid.major.y = element_line(linetype='dotted', color='#808080'),
                      panel.grid.major.x = element_blank()) + scale_y_discrete(labels=function(x) str_wrap(x, width=40))                 

      if (simple){
          simple.ego <- clusterProfiler::simplify(ego, cutoff=0.7, by="p.adjust", select_fun=min)
          simple.ego <- enrichplot::pairwise_termsim(simple.ego)           
          simgo.dir <- file.path(output, "simgo")
          if (!dir.exists(simgo.dir)) {
            dir.create(simgo.dir, recursive = T)
          }            
          outputsc.fig <- file.path(simgo.dir, paste(name, "_%s_simple.", format, sep = ""))
          outputsc.csv <- file.path(simgo.dir, paste(name, "_%s_simple.csv", sep = ""))
          emat  <-  simplifyEnrichment::GO_similarity(ego$ID, ont)
          df = tryCatch({
            df <- simplifyEnrichment::simplifyGO(emat)            
            title = sprintf("%s GO terms clustered by binary_cut", nrow(emat))
            ps <- simplifyEnrichment::ht_clusters(emat, df$cluster, column_title = title)
            
            save_fig(ps, 
                sprintf(outputsc.fig, ont), 
                format = format,
                width  = 12, 
                height = 10, 
                units  = "in")
            write.csv(df, file = sprintf(outputsc.csv, ont)) 

          }, warning = function(w) {
              print(w)
          }, error = function(e) {
            print(e)
            return(F)
          }
          )                 
      }
    }

    save_fig(p, 
        out.pdf, 
        format = format,
        width  = width, 
        height = height, 
        units  = "in")
}


compareClusterSep <- function(gene_ls, 
                              output, 
                              OrgDb, 
                              ont     = "BP",
                              name    = "GO",
                              keyType = 'ENSEMBL',
                              pval    = 0.1, 
                              qval    = 0.1,
                              width   = 12, 
                              height  = 10,
                              format  = "pdf") {

        if (ont == "ALL"){
          onts <- c("BP", "CC", "MF")
        } else {
          onts <- c(ont)
        }
        
        for (ont.i in onts){
          outputf <- file.path(output, paste(name, ".cmp.%s.qval%s_pval%s.%s", sep = "")) 
          out.pdf <- sprintf(outputf, ont.i, qval, pval, format)

          df = tryCatch({
              cpk <- compareCluster(gene_ls, 
                                    fun          = "enrichGO", 
                                    pvalueCutoff = pval,
                                    qvalueCutoff = qval,
                                    OrgDb        = OrgDb,
                                    ont          = ont.i,
                                    keyType      = keyType,
                                    readable     = TRUE) 

              }, warning = function(w) {
                  print(w)
              }, error = function(e) {

                pdf(out.pdf ,width = 12, height = 10)
                dev.off()            
                cpk  <- data.frame()
                return(cpk)
              }
              )
          if (class(df) == "data.frame"){
            cpk <- df
          }

          if (dim(as.data.frame(cpk))[1] == 0){

            pdf(out.pdf ,width = 12, height = 10)
            dev.off()
            next()           
          }
          p <- dotplot(cpk, title = sprintf("%s_%s",name, ont.i)) + 
                scale_color_gradientn(colours = c("#b3eebe", "#46bac2", "#371ea3"),
                                      guide   = guide_colorbar(reverse=TRUE, order=1)) +
                guides(size = guide_legend(override.aes=list(shape=1))) +
                theme(panel.grid.major.y = element_line(linetype='dotted', color='#808080'),
                      panel.grid.major.x = element_blank())
          save_fig(p, 
              out.pdf, 
              format = format,
              width  = width, 
              height = height, 
              units  = "in")
        }
}


comparePathwayCluster <- function(gene_ls, 
                               output, 
                               OrgDb, 
                               organism, 
                               database,
                               name    = "KEGG",
                               keyType = 'ENSEMBL',
                               pval    = 0.1, 
                               qval    = 0.1,
                               width   = 12, 
                               height  = 10,
                               format  = "pdf") {
    if (keyType == 'ENTREZID'){
        gene_ls  <-  gene_ls
    } else {
      gene_ls <- lapply(gene_ls, function(genes){
        genes <- bitr(genes, fromType = keyType, toType = "ENTREZID", OrgDb = OrgDb)$ENTREZID
        genes
      })
       
    }
      if (database == "KEGG"){
        enrich_func = "enrichKEGG"
      } else if (database == "Reactome"){
        enrich_func = ReactomePA::enrichPathway
      }
      cpk <- compareCluster(gene_ls, 
                            fun          = enrich_func, 
                            pvalueCutoff = pval,
                            qvalueCutoff = qval,
                            organism     = organism)

      if (dim(as.data.frame(cpk))[1] == 0){
        next()
      }
      outputf <- file.path(output, paste(name, ".cmp.qval%s_pval%s.pdf", sep = "")) 
      out.pdf <- sprintf(outputf, qval, pval)
      
      p <- dotplot(cpk, title = sprintf("%s",name))  + 
            scale_color_gradientn(colours = c("#b3eebe", "#46bac2", "#371ea3"),
                                  guide   = guide_colorbar(reverse=TRUE, order=1)) +
            guides(size = guide_legend(override.aes=list(shape=1))) +
            theme(panel.grid.major.y = element_line(linetype='dotted', color='#808080'),
                  panel.grid.major.x = element_blank())
      save_fig(p, 
          out.pdf, 
          format = format,
          width  = width, 
          height = height, 
          units  = "in")
}


enrichKEGGSep <- function(gene, 
                          out.dir, 
                          OrgDb, 
                          name    = "KEGG",
                          org     = "mmu", 
                          keytype = 'ENTREZID' ,
                          pval    = 0.1, 
                          qval    = 0.1,
                          width   = 12, 
                          height  = 10,
                          format  = "pdf") {

    if (keytype == 'ENTREZID'){
        gene  <-  gene
    } else {
       gene <- bitr(gene, fromType = keytype, toType = "ENTREZID", OrgDb = OrgDb)$ENTREZID
    }
    
    kk <- enrichKEGG(gene         = gene,
                     organism     = org, 
                     pvalueCutoff = pval,
                     qvalueCutoff = qval)

    if (!dir.exists(out.dir)){
        dir.create(out.dir, recursive = T)
    }

    if (dim(as.data.frame(kk))[1] == 0){
      print("nothing enrichment")  
      return()
    }                 

    out.fig.fmt <- file.path(out.dir, paste(name, ".qval%s_pval%s.%s", sep = ""))  
    out.csv.fmt <- file.path(out.dir, paste(name, ".qval%s_pval%s.csv", sep = ""))

    out.fig <- sprintf(out.fig.fmt, qval, pval, format)

    tryCatch({
        kp <- dotplot(kk, showCategory=30, title = name) + 
                scale_color_gradientn(colours = c("#b3eebe", "#46bac2", "#371ea3"),
                                      guide   = guide_colorbar(reverse=TRUE, order=1)) +
                guides(size = guide_legend(override.aes=list(shape=1))) +
                theme(panel.grid.major.y = element_line(linetype='dotted', color='#808080'),
                      panel.grid.major.x = element_blank())
        save_fig(kp, 
            out.fig, 
            format = format,
            width  = width, 
            height = height, 
            units  = "in")
        kk <- setReadable(kk, OrgDb = OrgDb, keyType="ENTREZID")
        write.csv(as.data.frame(kk), file = sprintf(out.csv.fmt, qval, pval))
      }, error = function(e) {
        print(e)
      })
}


enrichReactomeSep <- function(
                          gene, 
                          out.dir, 
                          OrgDb, 
                          name    = "Reactome",
                          org     = "mmu", 
                          keytype = 'ENTREZID' ,
                          pval    = 0.1, 
                          qval    = 0.1,
                          width   = 12, 
                          height  = 10,
                          format  = "pdf") {

    if (keytype == 'ENTREZID'){
        gene  <-  gene
    } else {
       gene <- bitr(gene, fromType = keytype, toType = "ENTREZID", OrgDb = OrgDb)$ENTREZID
    }
    
    kk <- ReactomePA::enrichPathway(
                     gene         = gene,
                     organism     = org, 
                     pvalueCutoff = pval,
                     qvalueCutoff = qval,
                     readable     = FALSE
                     )
    if (!dir.exists(out.dir)){
        dir.create(out.dir, recursive = T)
    }
    if (dim(as.data.frame(kk))[1] == 0){
      print("nothing enrichment")  
      return()
    }                 


    out.fig.fmt <- file.path(out.dir, paste(name, ".qval%s_pval%s.%s", sep = ""))  
    out.csv.fmt <- file.path(out.dir, paste(name, ".qval%s_pval%s.csv", sep = ""))

    out.fig <- sprintf(out.fig.fmt, qval, pval, format)

    tryCatch({
        kp <- dotplot(kk, showCategory=30, title = name) + 
                scale_color_gradientn(colours = c("#b3eebe", "#46bac2", "#371ea3"),
                                      guide   = guide_colorbar(reverse=TRUE, order=1)) +
                guides(size = guide_legend(override.aes=list(shape=1))) +
                theme(panel.grid.major.y = element_line(linetype='dotted', color='#808080'),
                      panel.grid.major.x = element_blank())
        save_fig(kp, 
            out.fig, 
            format = format,
            width  = width, 
            height = height, 
            units  = "in")
        write.csv(as.data.frame(kk), file = sprintf(out.csv.fmt, qval, pval))
      }, error = function(e) {
        print(e)
      })
}


## from  GOSemSim
load_OrgDb <- function(OrgDb) {
    if (is(OrgDb, "character")) {
        suppressMessages(require(OrgDb, character.only = TRUE))
        OrgDb <- eval(parse(text=OrgDb))
    }
    return(OrgDb)
}    


save_fig <- function(plot, 
                     filename, 
                     format = "png",
                     width  = 6, 
                     height = 6, 
                     units  = "in",
                     res    = 72){
  if (format == "pptx"){
      eoffice::topptx(plot, filename, width = width, height = height)
      cat(sprintf("Saving %s x %s in image\n", width, height))
  } else if (format == "png") {
      png(filename, width = width, height = height, units=units, res = res)
      print(plot)
      dev.off()
      cat(sprintf("Saving %s x %s in image\n", width, height))
  } else if (format == "pdf"){
      pdf(filename, width=width, height=height)
      print(plot)
      dev.off()
      cat(sprintf("Saving %s x %s in image\n", width, height))
  }
}


fig_cmd_parser <- function(){
    parser <- argparse::ArgumentParser()
    parser$add_argument("--output", help="file path")
    parser$add_argument("--fmt", help="figure format")
    parser$add_argument("--resolution", type="integer", help="resolution")
    parser$add_argument("--width", type="double", help="figure width")
    parser$add_argument("--height", type="double", help="figure height")
    return(parser)
}

readFasta <- function(file){
    dna <- Biostrings::readDNAStringSet(file)
    rna <- Biostrings::BStringSet(Biostrings::RNAStringSet(dna))
    return(rna)
}

suppressMessages(library(tidyverse))
suppressMessages(library(AnnotationDbi))
suppressMessages(library(tximport))
suppressMessages(library(DESeq2))
suppressMessages(library(tidyverse))
suppressMessages(library(GenomicFeatures))

script_path  <- stringr::str_split(commandArgs()[4], "=")[[1]][2]
source(file.path(dirname(script_path), "utils.R"))


parser <- argparse::ArgumentParser()

parser$add_argument("--psiMeta",  help="psi meta file path")
parser$add_argument("--tqMeta", help="quant.sh meta file path")
parser$add_argument("--organism", help="organism")
parser$add_argument("--database", help="database")
parser$add_argument("--txdb", help="txdb")
parser$add_argument("--fasta", help="fasta")
parser$add_argument("--output", help="output")


args <- parser$parse_args()

motif_dir <- file.path(dirname(dirname(script_path)), "data/motif")
if (args$database == "CISBP-RNA"){
   motif_path <- file.path(motif_dir, "CISBP-RNA", sprintf("%s.meme", args$organism))
   mf <- universalmotif::read_meme(motif_path)
    
} else {
   motif_path <- file.path(motif_dir, "ATtRACT",  sprintf("%s.meme", args$organism))
   mf <- universalmotif::read_meme(motif_path)
}


psi_meta_file <- args$psiMeta
sf_meta_file <- args$tqMeta

psi_meta <- read.csv(psi_meta_file)
sf_meta <- read.csv(sf_meta_file)

mean_psi_ls <- lapply(psi_meta$path, function(file){
    sub_psi_df  <- read.delim(file, sep = "\t")
    mean_psi <- rowMeans(sub_psi_df[, -1])
    names(mean_psi) <- sub_psi_df[, 1]
    mean_psi
})

psi_df <- Reduce(cbind, mean_psi_ls)

colnames(psi_df) <- psi_meta$group


txdb <- AnnotationDbi::loadDb(args$txdb)
k <- keys(txdb, keytype = "TXNAME")
tx2gene <- AnnotationDbi::select(txdb, k, "GENEID", "TXNAME")

txi <- tximport(sf_meta$path, type = "salmon", tx2gene = tx2gene)

sampleTable <- data.frame(condition = sf_meta$group)
rownames(sampleTable) <- sf_meta$name

dds <- DESeqDataSetFromTximport(txi, sampleTable, ~condition)

keep <- rowSums(counts(dds)) >= dim(sf_meta)[1] * 10
dds <- dds[keep,]

count.sf <-  estimateSizeFactors(dds)
normal.mtx <- counts(count.sf, normalized=T)


mean_exp_ls <- lapply(unique(sf_meta$group), function(g){
    gnames  <- sf_meta[sf_meta$group == g, "name"]
    rowMeans(normal.mtx[, gnames])
})

exp_df <- Reduce(cbind, mean_exp_ls)

colnames(exp_df) <- unique(sf_meta$group)
rownames(exp_df) <- sapply(strsplit(rownames(normal.mtx), "\\."), function(x)x[1])


fa <- unique(readFasta(args$fasta))

as_event_id <- sapply(strsplit(names(fa), "::"), function(x)x[1])

fa_pos <- sapply(strsplit(names(fa), "::"), function(x)x[2])


names(fa) <- paste(gsub(":", "_", as_event_id), fa_pos, sep="__")
fimo.out <-  memes::runFimo(fa, mf)  


fimo_df <- unique(as.data.frame(fimo.out))


motif_as_event_id <- sapply(strsplit(as.character(fimo_df$seqnames), "__"), function(x)x[1])
motif_as_event_id <- gsub("_", ":", motif_as_event_id)


rbp_id <- sapply(strsplit(fimo_df$motif_alt_id, ":"), function(x)x[2])

motif_link_df <- data.frame(
    "rbp" = fimo_df$motif_alt_id,
    "rbp_id" = rbp_id,
    "AS_event" = motif_as_event_id
)

cor_ls <- apply(motif_link_df, 1, function(x){
    rbp_exp <- as.numeric(exp_df[x["rbp_id"], ])
    as_event_psi <- as.numeric(psi_df[x["AS_event"], ])
    coor <- cor.test(rbp_exp, as_event_psi, method = "spearman")
    return(c(cor=coor$estimate, pval=coor$p.value, rbp=x["rbp_id"], AS_event=x["AS_event"]))

})

gene_cor <- as.data.frame(t(as.data.frame(cor_ls)))
colnames(gene_cor) <- c("cor", "pval", "rbp", "event")

gene_cor$motif_alt_id <- motif_link_df$rbp

high_link <- gene_cor[abs(as.numeric(gene_cor$cor)) > 0.8 & gene_cor$pval < 0.05, ]

write.csv(high_link, file = args$output, row.names=F)

library(stringr)
library(ggplot2)


args <- commandArgs()

dpsi_file <- args[6]
out <- args[7]



dpsi <- read.table(dpsi_file,  header=T, row.names=1, sep="\t")
dat <- na.omit(dpsi)

dat$type=str_split(rownames(dat),'[;:]',simplify = T)[,2]
event = dat$type[1]
dat$threshold = factor(ifelse(dat[,2] < 0.05 & abs(dat[,1]) >= 0,
                              ifelse(dat[,1] >= 0  ,'Up','Down'),'stable'),
                             levels=c('Up','Down','stable'))

colnames(dat)[1:2] <- c('dPSI', 'p.val')
dat[,'p.val'] = -log10(dat[, 'p.val'])

P_dpsi <- ggplot(dat,aes(dPSI, p.val, color = threshold))+
        geom_point() +
        theme_bw() +
        ylab(paste0(event,' pval')) + #修改y轴名称
        xlab(paste0(event,' dPSI')) + #修改x轴名称
        geom_vline(xintercept = c(-0.1,0.1), lty=3, col="black", lwd=0.5) + #添加横线|FoldChange|>2
        geom_hline(yintercept = 0.05, lty=3, col="black", lwd=0.5) 

ggsave(out, plot = P_dpsi)

suppressMessages(library(tidyverse))
suppressMessages(library(clusterProfiler))

script_path  <- stringr::str_split(commandArgs()[4], "=")[[1]][2]
source(file.path(dirname(script_path), "utils.R"))

parser <- fig_cmd_parser()
parser$add_argument("--outdir", help="output directory")
parser$add_argument("--pval", type="double", help="pval")
parser$add_argument("--qval", type="double", help="qval")
parser$add_argument("--database", help="database")
parser$add_argument("--ontology", help="ontology")
parser$add_argument("--orgdb", help="orgdb")
parser$add_argument("--genetype", help="gene type")
parser$add_argument("--organism", help="organism")
parser$add_argument("--files",  nargs='+', help="dpsi files")
parser$add_argument("--xlabel",  nargs='+', help="dpsi files")
parser$add_argument("--app", help="software output")

args <- parser$parse_args()

out.dir <- args$outdir
pval  <- args$pval
qval  <- args$qval
database <- args$database
orgdb <- args$orgdb
gene_type <- args$genetype
organism <- args$organism
dpsi_files <- args$files
xlabel <- args$xlabel
ontology <- args$ontology
app <- args$app

suppressMessages(library(orgdb, character.only = T))


filenames <- unlist(lapply(dpsi_files, function(file){
                            tools::file_path_sans_ext(basename(file))
                        }))   

if (length(unique(xlabel)) == length(dpsi_files)){
    filenames <- xlabel
} else if (length(filenames) != length(unique(filenames))) {
   filenames <- paste(filenames, seq(1, length(filenames)), sep=".") 
} else {
   filenames <- filenames
}

gene_ls <- lapply(dpsi_files, function(file){
    if (app == "SUPPA2"){
        dpsi <- read_tsv(file, 
                        skip      = 1, 
                        col_names = F,
                        col_types = cols("c", "d", "d")
                        )
        colnames(dpsi) = c("event_id", "dpsi", "pval")
        genes <- gsub("\\..*", "",  dpsi$event_id)  
    } else if (app == "rMATS"){
        df  <-  read_tsv(file)
        genes <- gsub("\\..*", "",  df$GeneID)   
    } else if (app == "EventPointer"){
    df  <-  read_csv(file)
    if (! "Gene" %in% colnames(df)){
        df  <-  read.table(file) 
    }
        genes <- gsub("\\..*", "",  df$Gene) 
    }
    return(genes)
})

names(gene_ls) <- filenames

if (database == "GO"){
    compareClusterSep(gene_ls, 
                        out.dir, 
                        orgdb,
                        ont     = ontology,
                        name    = "GO", 
                        keyType = gene_type,
                        pval    = pval, 
                        qval    = qval,
                        width   = args$width, 
                        height  = args$height,
                        format  = args$fmt)
}else if (database %in% c("KEGG", "Reactome")) {
    comparePathwayCluster(gene_ls, 
                        out.dir, 
                        orgdb, 
                        organism,
                        database,
                        name    = database, 
                        keyType = gene_type,
                        pval    = pval, 
                        qval    = qval,
                        width   = args$width, 
                        height  = args$height,
                        format  = args$fmt)
}

script_path  <- stringr::str_split(commandArgs()[4], "=")[[1]][2]
source(file.path(dirname(script_path), "utils.R"))


parser <- fig_cmd_parser()

parser$add_argument("--file", nargs='+', help="file names")
parser$add_argument("--name", nargs='+', help="file path")
parser$add_argument("--dg", action='store_true', help="dg")


args <- parser$parse_args()

files <- args$file
names(files) <- args$name

if (args$dg){
    evnet_id.ls <- lapply(files, function(x){
        df <- readr::read_tsv(x, skip = 1, show_col_types = FALSE)
        colnames(df)[1] <- "event_id"
        list(pos = df[df[2]>0, ]$event_id,
             neg = df[df[2]<0, ]$event_id)
    })
    evnet_id.ls <- unlist(evnet_id.ls, recursive = F)
    repN <- 2 

} else {
    evnet_id.ls <- lapply(files, function(x){
        df <- readr::read_tsv(x, skip = 1, show_col_types = FALSE)
        colnames(df)[1] <- "event_id"
        df$event_id
    })  
    repN <- 1 
}


pre_colors <- c("#a1d9f9", "#d69bc5", "#ff9999", "#ffc799", "#99d1b8")

colors <- pre_colors[1:length(files)]
colors[is.na(colors)] <- "black"
colors <- rep(colors, each=repN)


p <- UpSetR::upset(UpSetR::fromList(evnet_id.ls), 
                   nsets          = length(files), 
                   keep.order     = TRUE, 
                   sets           = names(evnet_id.ls), 
                   matrix.color   = "red", 
                   main.bar.color = "black",
                   sets.bar.color = colors)


save_fig(p, 
        args$output, 
        format = args$fmt,
        width  = args$width, 
        height = args$height, 
        units  = "in",
        res    = args$resolution)

suppressMessages(library(tidyverse))
suppressMessages(library(Biostrings))

script_path  <- stringr::str_split(commandArgs()[4], "=")[[1]][2]
source(file.path(dirname(script_path), "utils.R"))


parser <- fig_cmd_parser()

parser$add_argument("--outdir", help="output directory")
parser$add_argument("--meme", help="meme motif")
parser$add_argument("--fasta", nargs="+", help="fasta files")
parser$add_argument("--step", type="integer", help="slide window step size")
parser$add_argument("--bin", type="integer", help="bin size")
parser$add_argument("--seqid", nargs="+", help="fasta files id")
parser$add_argument("--center", nargs="+", type="integer", help="fasta files")
parser$add_argument("--meme_path ", help="meme_path ")

args <- parser$parse_args()

step <- args$step
win <- args$bin
meme <- args$meme

seq_files <- args$fasta
seq_names <- args$seqid
centers <- args$cente
meme_ls <- universalmotif::read_meme(meme)

if (class(meme_ls) != "list"){
    meme_ls  <-  list(meme_ls)

}

motif_names <- sapply(meme_ls, function(x) x@name)
motif_lens  <-  sapply(meme_ls, function(x) dim(x@motif)[2])
max_motif_len <- max(motif_lens)

names(seq_files)  <- seq_names
names(centers) <- seq_names

df_ls <- lapply(seq_names, function(n){
    faset <- readBStringSet(seq_files[n])
    seq_len <- width(faset)[1]
    starts <- seq(1, seq_len, by = step) 
    win_starts <- starts[(seq_len-starts+1) >= max_motif_len] 
    res_ls <- lapply(win_starts, function(s){
        if (s == win_starts[length(win_starts)]){
            subfa <- subseq(faset, start=s, end=min(width(faset))) 
        }
        else {
           subfa <- subseq(faset, start=s, end=NA, width=win) 
        }
        res <- memes::runFimo(subfa, meme_ls, meme_path = args$meme_path)
        return(res)
    })

    motif_count <- lapply(res_ls, function(x) {
        counts <- sapply(motif_names, function(n){
            xdf <- as.data.frame(x)
            dim(xdf[xdf$motif_id == n,])[1]
        })
        names(counts) <- motif_names
        counts
    })

    count_df <-  data.frame(t(sapply(motif_count,c)))
    len_factor <- motif_lens / max_motif_len
    count_df <- as.data.frame(mapply('/', count_df, len_factor))
    colnames(count_df) <- motif_names
    new_motif_names <- colnames(count_df)

    count_df$pos <- win_starts - centers[n]
    count_df$seqId <- n

    long_data <- count_df %>% 
        gather(all_of(new_motif_names), key="motif_id", value ="count") %>% 
        mutate(count = count / length(faset))
    long_data
})

all_df <- Reduce(rbind, df_ls)

r <- lapply(unique(all_df$motif_id), function(x){
    p <- ggplot(data = all_df[all_df$motif_id ==x, ]) +
        theme_bw() +
        geom_line(mapping = aes(x = pos, y=count, group=motif_id), color="#83cdfd") + 
        scale_fill_manual(values = c('pink', "#83cdfd")) + 
        facet_wrap(~seqId, ncol = length(seq_names), scales = "free_x") +
        labs(x = "Relative Position", y="Motif Coverage") + 
        ggtitle("RNA map")
    output <- file.path(args$outdir, sprintf("%s.%s", x, args$fmt))

    save_fig(p, 
            output, 
            format = args$fmt,
            width  = args$width, 
            height = args$height, 
            units  = "in",
            res    = args$resolution)
})

suppressMessages(library(tidyverse))
suppressMessages(library(clusterProfiler))

script_path  <- stringr::str_split(commandArgs()[4], "=")[[1]][2]
source(file.path(dirname(script_path), "utils.R"))

parser <- fig_cmd_parser()
parser$add_argument("--outdir", help="output directory")
parser$add_argument("--pval", type="double", help="pval")
parser$add_argument("--qval", type="double", help="qval")
parser$add_argument("--database", help="database")
parser$add_argument("--ontology", help="ontology")
parser$add_argument("--orgdb", help="orgdb")
parser$add_argument("--genetype", help="gene type")
parser$add_argument("--organism", help="kegg organism")
parser$add_argument("--file", help="dpsi files")
parser$add_argument("--simple", action='store_true', help="simple")
parser$add_argument("--app", help="software output")

args <- parser$parse_args()

out.dir <- args$outdir
pval  <- args$pval
qval  <- args$qval
db <- args$database
ontology <- args$ontology
gene_type <- args$genetype
org_db <- args$orgdb
organism <- args$organism
dpsi_file <- args$file
app <- args$app

suppressMessages(library(org_db, character.only = T))

if (app == "SUPPA2"){
    dpsi <- read_tsv(dpsi_file, 
                    skip      = 1, 
                    col_names = F,
                    col_types = cols("c", "d", "d"))

    colnames(dpsi) = c("event_id", "dpsi", "pval")
    genes <- gsub("\\..*", "",  dpsi$event_id)  
} else if (app == "rMATS"){
    df  <-  read_tsv(dpsi_file)
    genes <- gsub("\\..*", "",  df$GeneID)   
} else if (app == "EventPointer"){
    df  <-  read_csv(dpsi_file)
    if (! "Gene" %in% colnames(df)){
        df  <-  read.table(dpsi_file)  
    }
    genes <- gsub("\\..*", "",  df$Gene) 
}


if (db == "GO"){
    p <- enrichGOSep(genes, 
                out.dir,
                org_db, 
                name    = "GO",
                ont     = ontology,
                keyType = gene_type,
                pval    = pval, 
                qval    = qval,
                simple  = args$simple,
                width   = args$width, 
                height  = args$height,
                format  = args$fmt)
} else if (db == "KEGG") {
    enrichKEGGSep(genes, 
                  out.dir, 
                  org_db, 
                  name    = "KEGG",
                  org     = organism, 
                  keytype = gene_type,
                  pval    = pval, 
                  qval    = qval,
                  width   = args$width, 
                  height  = args$height,
                  format  = args$fmt)
} else if (db == "Reactome") {
    enrichReactomeSep(genes, 
                  out.dir, 
                  org_db, 
                  name    = "Reactome",
                  org     = organism, 
                  keytype = gene_type,
                  pval    = pval, 
                  qval    = qval,
                  width   = args$width, 
                  height  = args$height,
                  format  = args$fmt)
}

script_path  <- stringr::str_split(commandArgs()[4], "=")[[1]][2]
source(file.path(dirname(script_path), "utils.R"))

parser <- fig_cmd_parser()

parser$add_argument("--meme", help="meme file path")
parser$add_argument("--motifId", nargs="+", help="meme file path")

args <- parser$parse_args()

meme_ls <- universalmotif::read_meme(args$meme)

mf <- universalmotif::filter_motifs(meme_ls, name = args$motifId)

p <- universalmotif::view_motifs(mf)


save_fig(p, 
        args$output, 
        format = args$fmt,
        width  = args$width, 
        height = args$height, 
        units  = "in",
        res    = args$resolution)

script_path  <- stringr::str_split(commandArgs()[4], "=")[[1]][2]
source(file.path(dirname(script_path), "utils.R"))

parser <- fig_cmd_parser()

parser$add_argument("--pwm", help="pwm file path")


args <- parser$parse_args()

pwm <- universalmotif::read_matrix(args$pwm, headers = ">", positions = "rows")


p <- universalmotif::view_motifs(pwm, use.type = "PPM")
# motif <- universalmotif::convert_type(pwm, "PPM")
# ## Only need the matrix itself
# motif <- motif["motif"]
# p <- seqLogo::seqLogo(motif)

save_fig(p, 
        args$output, 
        format = args$fmt,
        width  = args$width, 
        height = args$height, 
        units  = "in",
        res    = args$resolution)

#########################################################################
# COPYRIGHT (C) 2003         EDF R&D              WWW.CODE-ASTER.ORG    #
#                                                                       #
# THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR         #
# MODIFY IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS        #
# PUBLISHED BY THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE    #
# LICENSE, OR (AT YOUR OPTION) ANY LATER VERSION.                       #
# THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL,       #
# BUT WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF        #
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      #
# GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              #
#                                                                       #
# YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     #
# ALONG WITH THIS PROGRAM; IF NOT, WRITE TO : EDF R&D CODE_ASTER,       #
#    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.        #
#########################################################################

# $Id: sum_tps.awk 2075 2006-08-31 16:39:31Z courtois $

BEGIN { FS=":"; s=0; }
{
   if(NF==4) { s+=86400*$1+3600*$2+60*$3+$4; }
   else if(NF==3) { s+=3600*$1+60*$2+$3; }
   else if(NF==2) { s+=60*$1+$2; }
   else if(NF==1) { s+=$1; }
}
END {
   if(s==0) {
      print "_";
   } else {
      print s;
   }
}

# $Id: aster_profile.sh 2252 2006-09-13 12:17:43Z courtois $
#
# aster_profile.sh : initialize the environment for astk services
# (sh, ksh, bash syntax)
#
# If variables are depending on Code_Aster version, use ENV_SH in
# the corresponding 'config.txt' file.
#
# $ASTER_VERSION is now obsolete.
#
ASTER_ROOT=?ASTER_ROOT?
export ASTER_ROOT

LD_LIBRARY_PATH=?HOME_PYTHON?/lib:$ASTER_ROOT/public/lib:$LD_LIBRARY_PATH
export LD_LIBRARY_PATH

# this should not be usefull...
#PYTHONHOME=?HOME_PYTHON?
#export PYTHONHOME

# optional settings
# DO NOT EDIT FOLLOWING LINE !
#?OPT_ENV?
